<?php

namespace app\models;

use Yii;
use yii\db\ActiveRecord;
use yii\web\IdentityInterface;
/**
 * This is the model class for table "{{%user}}".
 *
 * @property integer $id
 * @property string $username
 * @property string $password
 * @property string $authkey
 * @property string $accesstoken
 */
class User extends \yii\db\ActiveRecord implements IdentityInterface
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    { return '{{%user}}'; }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
           // [['idusuario'], 'required'],
           // [['idusuario'], 'integer'],
         //   [['idusuario'], 'unique'],
            [['username'], 'unique'],
            [['username','password'], 'required'],
            
          //   [['idempresa','idestudio'], 'integer'],
            [['accesstoken'], 'string', 'max' => 45],
            [['username', 'password'], 'string', 'max' => 10],
            [['descrip'], 'string'],
            
        ];
    }

    /**
     * @inheritdoc
     */
 public function attributeLabels()
    {
        return [
            'idusuario' => Yii::t('app', 'IDUSUARIO'),
            'username' => Yii::t('app', 'Username'),
            'password' => Yii::t('app', 'Password'),
            'authkey' => Yii::t('app', 'Authkey'),
            'accesstoken' => Yii::t('app', 'Accesstoken'),
        ];
    }
    
    public static function findIdentityByAccessToken($token, $type = null)
    { return static::findOne(['access_token' => $token]); }

    /**
     * @return int|string current user ID
     */
    public function getId()
    {return $this->idusuario; }

    /**
     * @return string current user auth key
     */
    public function getAuthKey()
    {return $this->authkey;}

    /**
     * @param string $authKey
     * @return bool if auth key is valid for current user
     */
    public function validateAuthKey($authKey)
    {return $this->getAuthKey() === $authKey;}
    
    public static function findIdentity($idusuario)
    {return static::findOne($idusuario); }
    /**
     * @inheritdoc
     * @return UserQuery the active query used by this AR class.
     */
 public static function find()
    { return new UserQuery(get_called_class()); }
    

 public static function findByUsername($username)
    {  $user = User::find()->where(['username'=>$username])->one() ;
        return new static($user);
    }    
public function validatePassword($password)
    {
        return $this->password === $password;
    }    

    /**
     * @inheritdoc
     */
  
    
}
